#ifndef EFL_GENERATED_ELM_SYS_NOTIFY_DBUS_HH
#define EFL_GENERATED_ELM_SYS_NOTIFY_DBUS_HH

extern "C"
{
#include <Efl.h>
}
#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_sys_notify_dbus.eo.h"
}

#include "eo_base.eo.hh"
#include "elm_sys_notify_interface.eo.hh"

namespace elm { namespace sys_notify {

struct dbus;

} }

/// @cond EO_CXX_ABSTRACT
namespace eo_cxx {

namespace elm { namespace sys_notify {

struct dbus
{


   static Eo_Class const* _eo_class()
   {
      return(ELM_SYS_NOTIFY_DBUS_CLASS);
   }

   operator ::elm::sys_notify::dbus() const;
   operator ::elm::sys_notify::dbus&();
   operator ::elm::sys_notify::dbus const&() const;

   /// @cond LOCAL
   template <typename D>
   struct address_of
   {
      operator ::elm::sys_notify::dbus*() const { return static_cast<::elm::sys_notify::dbus*>(static_cast<D const*>(this)->p); }
      operator ::elm::sys_notify::dbus const*() const { return static_cast<::elm::sys_notify::dbus const*>(static_cast<D const*>(this)->p); }
   };

   template <typename D>
   struct address_const_of
   {
      operator ::elm::sys_notify::dbus const*() const { return static_cast<::elm::sys_notify::dbus const*>(static_cast<D const*>(this)->p); }
   };
   /// @endcond

private:

   /// @internal
   Eo* _concrete_eo_ptr() const
   {
      return static_cast<::efl::eo::concrete const*>(static_cast<void const*>(this))->_eo_ptr();
   }

};

} }

}
/// @endcond

namespace elm { namespace sys_notify {

/// @brief Class dbus
struct dbus
      : ::efl::eo::concrete
      , EO_CXX_INHERIT(elm::sys_notify_interface)
      , EO_CXX_INHERIT(eo::base)
{
   //@{
   /**
      @brief Constructs a new elm::sys_notify::dbus object.

      Constructs a new elm::sys_notify::dbus object. If you want this object to be a child
      of another Eo object, use an @ref efl::eo::parent expression, like the example.

      Example:
      @code
      elm::sys_notify::dbus my_dbus(efl::eo::parent = parent_object);
      @endcode

      @see dbus(Eo* eo)
   */
   explicit dbus(::efl::eo::parent_type _p)
      : dbus(_ctors_call(_p))
   {}

   explicit dbus()
      : dbus(_ctors_call(::efl::eo::parent = nullptr))
   {}
   //@}

   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit dbus(Eo* eo)
      : ::efl::eo::concrete(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit dbus(std::nullptr_t)
      : ::efl::eo::concrete(nullptr)
   {}

   /// @brief Copy Constructor.
   ///
   dbus(dbus const& other)
      : dbus(eo_ref(other._eo_ptr()))
   {}

   ~dbus() {}

   template <typename F>
   ::efl::eo::signal_connection
   callback_callback_add_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (EO_BASE_EVENT_CALLBACK_ADD, priority_,
            &::efl::eo::_detail::event_callback<::elm::sys_notify::dbus, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm::sys_notify::dbus, function_type>,
         EO_BASE_EVENT_CALLBACK_ADD );
   }

   template <typename T>
   void
   callback_callback_add_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (EO_BASE_EVENT_CALLBACK_ADD, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_callback_del_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (EO_BASE_EVENT_CALLBACK_DEL, priority_,
            &::efl::eo::_detail::event_callback<::elm::sys_notify::dbus, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm::sys_notify::dbus, function_type>,
         EO_BASE_EVENT_CALLBACK_DEL );
   }

   template <typename T>
   void
   callback_callback_del_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (EO_BASE_EVENT_CALLBACK_DEL, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_del_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (EO_BASE_EVENT_DEL, priority_,
            &::efl::eo::_detail::event_callback<::elm::sys_notify::dbus, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm::sys_notify::dbus, function_type>,
         EO_BASE_EVENT_DEL );
   }

   template <typename T>
   void
   callback_del_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (EO_BASE_EVENT_DEL, info));
   }



   static Eo_Class const* _eo_class()
   {
      return(ELM_SYS_NOTIFY_DBUS_CLASS);
   }

   /// @cond LOCAL
   struct address_of
      : ::eo_cxx::elm::sys_notify::dbus::address_of<address_of>
      , ::eo_cxx::elm::sys_notify_interface::address_of<address_of>
      , ::eo_cxx::eo::base::address_of<address_of>
      , ::efl::eo::detail::concrete_address_of
   {
      explicit address_of(::elm::sys_notify::dbus* p)
         : ::efl::eo::detail::concrete_address_of(p)
      {}
   };
   address_of operator&() { return address_of(this); }

   struct address_const_of
      : ::eo_cxx::elm::sys_notify::dbus::address_const_of<address_const_of>
      , ::eo_cxx::elm::sys_notify_interface::address_const_of<address_const_of>
      , ::eo_cxx::eo::base::address_const_of<address_const_of>
      , ::efl::eo::detail::concrete_address_const_of
   {
      explicit address_const_of(::elm::sys_notify::dbus const* p)
         : ::efl::eo::detail::concrete_address_const_of(p)
      {}
   };
   address_const_of operator&() const { return address_const_of(this); }

   /// @endcond

private:

   /// @internal
   static Eo* _ctors_call(::efl::eo::parent_type _p)
   {
      Eo* _ret_eo = eo_add_ref(ELM_SYS_NOTIFY_DBUS_CLASS, _p._eo_raw);

      return _ret_eo;
   }

   /// @internal
   Eo* _concrete_eo_ptr() const { return _eo_ptr(); }
};

static_assert(sizeof(::elm::sys_notify::dbus) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<::elm::sys_notify::dbus>::value, "");

} }


#include "elm_sys_notify_dbus.eo.impl.hh"

#endif // EFL_GENERATED_ELM_SYS_NOTIFY_DBUS_HH

